import "dart:io";
import "dart:async";
import "dart:json";

import "package:logging/logging.dart";
import 'package:logging_handlers/server_logging_handlers.dart';

import "restful/restful_server.dart";
import 'dart:utf';

void main() {
  Logger.root.onRecord.listen(new PrintHandler());


  RestfulServer server = new RestfulServer(host:InternetAddress.ANY_IP_V4, port:1337);
  
  var old = server.preProcessor;
  
  server.preProcessor = (request) {
    request.response.headers.contentType = ContentTypes.APPLICATION_JSON;
    old(request);
  };

  server
    ..onGet("/gah/{version}/{appId}", (request, uriParams) {
      request.response.write("Физкульт Привет! $uriParams");
    })
    ..onGet("/error", (request, uriParams) {
      throw "baaah";
    })
    ..onHead("/gah/{version}/{appId}", (request, uriParams) {
      request.response.write("Getting head... $uriParams");
    })
    ..onOptions("/gah/{version}/{appId}", (request, uriParams) {
      request.response.write("Strangle the iron condor... $uriParams");
    })
    ..onPost("/post2", (request, uriParams) {
      request.response.write("post called with");
    })
    ..onPost("/post", (request, uriParams, body) {
      request.response.write("post called with $body");
    });
}


